### Name: cast
### Title: Cast function
### Aliases: cast
### Keywords: manip

### ** Examples
#Air quality example
names(airquality) <- tolower(names(airquality))
airquality.d <- melt(airquality, id=c("month", "day"))

cast(airquality.d, month ~ variable, mean)
cast(airquality.d, month ~ variable, mean, margins=c("grand_row", "grand_col"))
cast(airquality.d, day ~ month, mean, subset=variable=="ozone")
cast(airquality.d, month ~ variable, range)
cast(airquality.d, month ~ variable + result_variable, range)

#Chick weight example
names(ChickWeight) <- tolower(names(ChickWeight))
chick.d <- melt(ChickWeight, id=2:4)

cast(chick.d, time ~ variable, mean) # average effect of time
cast(chick.d, diet ~ variable, mean) # average effect of diet

# How many chicks at each time? - checking for balance
cast(chick.d, time ~ diet, length)
cast(chick.d, chick ~ time, mean)
cast(chick.d, chick ~ time, mean, subset=time < 10 & chick < 20)

cast(chick.d, diet + chick ~ time)
cast(chick.d, diet + chick ~ time, mean, margins="diet")
#Tips example
data(tips)
cast(melt(tips), sex ~ smoker, mean, subset=variable=="total_bill")

data(french_fries)
ff_d <- melt(french_fries, id=1:4)
cast(ff_d, subject ~ time, length)
cast(ff_d, subject ~ time, function(x) 30 - length(x))
cast(ff_d, variable ~ ., function(x) c(min=min(x), max=max(x)))
cast(ff_d, treatment ~ variable, mean, margins=c("grand_col", "grand_row"))
cast(ff_d, treatment + subject ~ variable, mean, margins="treatment", subset=subject < 5)
lattice::xyplot(X1 ~ X2 | variable, cast(ff_d, ... ~ rep), aspect="iso")


